
/**
 * Representar una linea de detalle dentro de la factura.
 * 
 * @author G. Cherencio 
 * @version 1.0
 */
public class Detalle {
    // ATRIBUTOS
    
    private Producto producto;
    private int cantidad;
    private double precio;
    
    // CONSTRUCTORES
    /**
     * Constructor for objects of class Detalle
     */
    public Detalle(){
        this(new Producto());
    }
    public Detalle(Producto p){
        this(p,1);
    }
    public Detalle(Producto p, int c){
        this(p,c,1.0);
    }
    public Detalle(Producto p,int c, double pr){
        setProducto(p);
        setCantidad(c);
        setPrecio(pr);
    }

    // GETTERS
    public Producto getProducto() { return producto; }
    public int getCantidad()      { return cantidad; }
    public double getPrecio()     { return precio;   }
    
    // SETTERS
    public void setProducto(Producto p) { producto = p; }
    public void setCantidad(int c)      { cantidad = c; }
    public void setPrecio(double p)     { 
        if ( p < getProducto().getPrecio() ) {
            double dif = producto.getPrecio() - p;
            System.err.println("Atencion! Ud esta facturando $ "+dif+" por debajo del precio de lista!");
        } else if (p > getProducto().getPrecio()) {
            double dif = p - producto.getPrecio();
            System.err.println("Atencion! Ud esta facturando $ "+dif+" por encima del precio de lista!");
        }
        precio = p;   
    }
    
    // CUSTOM
    public double getSubtotal() { return cantidad * precio; }
}
